/*
 * UART_FIFO.c
 *
 *  Created on: 2013-3-18
 *      Author: Administrator
 */


#include "MSP430G2553.h"
#include "UART_Global.h"
/******************************************************************************************************
 *        ƣRx_FIFO_WriteChar()
 *        ܣRxFIFOд1ֽ
 * ڲDataдFIFO
 * ڲ1дݳɹ0дʧ
 * ˵       FIFOʱҪرж
 *        
 ******************************************************************************************************/
char Rx_FIFO_WriteChar(unsigned char Data)
{
	if(Rx_FIFO_DataNum==RX_FIFO_SIZE) return(0); //жFIFOǷװδݣװ0
	_disable_interrupts();                       						//FIFOǰһҪж
	Rx_FIFO_DataNum++;                           					//δȡݸһ
	Rx_FIFO[Rx_FIFO_IndexW]=Data;                			//ддָλõFIFO
	Rx_FIFO_IndexW++;                            					//дָλ
	if (Rx_FIFO_IndexW>=RX_FIFO_SIZE)           			//жָǷԽ
		Rx_FIFO_IndexW=0;                        					//дָѭ
	_enable_interrupts();                        						//ָжʹ
	return(1);																//سɹ
}
/******************************************************************************************************
 *        ƣRx_FIFO_ReadChar()
 *        ܣRxFIFOж1ֽ
 * ڲ*Chrֽڱָ
 * ڲ1ȡݳɹ0ȡʧ
 * ˵       FIFOʱҪرж
 *        
 ******************************************************************************************************/
char Rx_FIFO_ReadChar(unsigned char *Chr)
{
	if(Rx_FIFO_DataNum==0) return(0);			//жFIFOǷδݣûз0
	_disable_interrupts();								//FIFOǰһҪж
	Rx_FIFO_DataNum--;									//ȡݸһ
	*Chr=Rx_FIFO[Rx_FIFO_IndexR];					//ָλõFIFOݸָָ
	Rx_FIFO_IndexR++;										//ָλ
	if (Rx_FIFO_IndexR>=RX_FIFO_SIZE) 			//жָǷԽ
		Rx_FIFO_IndexR=0;									//ָѭ
	_enable_interrupts();									//ָжʹ
	return(1);
}

/******************************************************************************************************
 *        ƣRx_FIFO_Clear()
 *        ܣRxFIFO
 * ڲ
 * ڲ
 * ˵       ղҪȥFIFOÿһֽڵд0
 * 					ֻдָͿ㼴ɡ
 *        
 ******************************************************************************************************/
void Rx_FIFO_Clear()
{
	_disable_interrupts();					//FIFOǰһҪж
	Rx_FIFO_DataNum=0;						//FIFOδȡĿ
	Rx_FIFO_IndexR=0;							//FIFOģָ
	Rx_FIFO_IndexW=0;						//FIFOģдָ
	_enable_interrupts();						//ָжʹ
}
/******************************************************************************************************
 *        ƣTx_FIFO_WriteChar()
 *        ܣTxFIFOд1ֽ
 * ڲDataдFIFO
 * ڲ1дݳɹ0дʧ
 * ˵       ȫ¡һηݱֶTxжϣȫ¡һֶTxжϡ
 * 						ȫ·͵оݱͬʱFIFOݺTxBusy
 *        
 ******************************************************************************************************/
char Tx_FIFO_WriteChar(unsigned char Data)
{
	if(Tx_FIFO_DataNum==TX_FIFO_SIZE) return(0);		//жFIFOǷװδݣװ0
	_disable_interrupts();                   								//FIFOǰһҪж
	//-----ȫ¡һηݱֶTxж-----
	if((Tx_FIFO_DataNum==0) &&( !(UCA0STAT & UCBUSY)))		//жǷΪһΡȫ¡
		IFG2 |=UCA0TXIFG;													// ֶһ
	Tx_FIFO_DataNum++;                                 				//δȡݸһ
	Tx_FIFO[Tx_FIFO_IndexW]=Data;                      			//ддָλõFIFO
	Tx_FIFO_IndexW++;                                  					//дָλ
	if (Tx_FIFO_IndexW >= TX_FIFO_SIZE)                		//жָǷԽ
		Tx_FIFO_IndexW=0;                              					//дָѭ
	_enable_interrupts();                              					//ָжʹ
	return(1);																	//سɹ
}
/******************************************************************************************************
 *        ƣTx_FIFO_ReadChar()
 *        ܣTxFIFOж1ֽ
 * ڲ*Chrֽڱָ
 * ڲ1ȡݳɹ0ȡʧ
 * ˵       FIFOʱҪرж
 *        
 ******************************************************************************************************/
char Tx_FIFO_ReadChar(unsigned char *Chr)
{
	if(Tx_FIFO_DataNum==0) return(0);      //жFIFOǷδݣûз0
	_disable_interrupts();                 			//FIFOǰһҪж
	Tx_FIFO_DataNum--;                     			//ȡݸһ
	*Chr=Tx_FIFO[Tx_FIFO_IndexR];          	//ָλõFIFOݸָָ
	Tx_FIFO_IndexR++;                      			//ָλ
	if (Tx_FIFO_IndexR>=TX_FIFO_SIZE)      //жָǷԽ
		Tx_FIFO_IndexR=0;                  			//ָѭ
	_enable_interrupts();                  			//ָжʹ
	return(1);												//سɹ
}

/******************************************************************************************************
 *        ƣTx_FIFO_Clear()
 *        ܣTxFIFO
 * ڲ
 * ڲ
 * ˵       ղҪȥFIFOÿһֽڵд0
 * 					ֻдָͿ㼴ɡ
 *        
 ******************************************************************************************************/
void Tx_FIFO_Clear()
{
	_disable_interrupts();        	//FIFOǰһҪж
	Tx_FIFO_DataNum=0;            //FIFOδȡĿ
	Tx_FIFO_IndexR=0;             		//FIFOģָ
	Tx_FIFO_IndexW=0;            	 //FIFOģдָ
	_enable_interrupts();         	//ָжʹ
}
