/*
 * SPI.c
 * CKPHCKPLλĲͬSPIʱ4Լ
 * ļCKPH=0CKPL=0ģʽ
 * 1CLKTx½Rx
 * 2ʱӿ״̬Ϊ͵ƽ
 * 3CS͵ƽʹܺĵһCLKؿʼշݡ
 *  Created on: 2013-4-3
 *      Author: Administrator
 */

#include"MSP430G2553.h"
#include"SPI.h"

#ifdef	SOFT_SPI				//Begin of SOFT_SPI
static unsigned char SPI_Delay=50;			//=5us
#define DelayMCLK_FREQ			12000000		//ھȷʱ
//-----ԴӻʹCSSTEź궨-----
#define SPI_CS_HIGH			P2OUT |=BIT4
#define SPI_CS_LOW			P2OUT &=~BIT4
//-----ͨʱCLKź궨-----
#define SPI_CLK_HIGH		P1OUT |=BIT4
#define SPI_CLK_LOW		P1OUT &=~BIT4
//-----ԴSIMOź궨-----
#define SPI_SIMO_HIGH	P1OUT |=BIT2
#define SPI_SIMO_LOW		P1OUT &=~BIT2
//-----ԴӷSOMIź궨-----
#define SPI_SOMI_IN			P1IN &BIT1
/******************************************************************************************************
 *        ƣSPI_init(void)
 *        ܣӲSPIĳʼ
 * ڲ
 * ڲ
 * ˵       ʵʹǳʼSPIIOķ
 *        
 ******************************************************************************************************/
void SPI_init(void)
{
	P1DIR |=BIT2+BIT4;
	P2DIR |= BIT4;
	P1DIR &=~BIT1;
}
/******************************************************************************************************
 *        ƣSPI_CS_High(void)
 *        ܣϲ㺯ĵ
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
void SPI_CS_High(void)
{
	SPI_CS_HIGH;
}
/******************************************************************************************************
 *        ƣSPI_CS_Low(void)
 *        ܣϲ㺯ĵ
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
void SPI_CS_Low(void)
{
	SPI_CS_LOW;
}
/******************************************************************************************************
 *        ƣdelay_us()
 *        ܣusʱ
 * ڲ
 * ڲ
 * ˵       ͨȫֱSPI_Delay
 *        
 ******************************************************************************************************/
static void delay_us(void)
{
	unsigned int i=0;
	for(i=0;i<SPI_Delay;i++)
		__delay_cycles(DelayMCLK_FREQ/10000000);		//usʱ
}
/******************************************************************************************************
 *        ƣTx_Char()
 *        ܣӻ1ֽ
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
void Tx_Char(unsigned char data)
{
	unsigned char i=0;
	for(i=0;i<8;i++)
	{
		SPI_CLK_LOW;			delay_us();
		if((data<<i)&BIT7)			SPI_SIMO_HIGH;
		else		SPI_SIMO_LOW;
		delay_us();
		SPI_CLK_HIGH;		delay_us();
	}
}
/******************************************************************************************************
 *        ƣRx_Char()
 *        ܣմӻ1ֽ
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
unsigned char Rx_Char()
{
	unsigned char i=0;
	unsigned char Temp=0;
	for(i=0;i<8;i++)
	{
		SPI_CLK_HIGH;		delay_us();
		SPI_CLK_LOW ;		delay_us();
		Temp=Temp<<1;		//λǰ
		if(SPI_SOMI_IN )			//ոλ
			Temp |=BIT0;			//1
//		else Temp &=~BIT0;	//ʡԣĬϾ0
	}
	return Temp;
}
/******************************************************************************************************
 *        ƣSPI_TxFrame()
 *        ܣӻ1֡
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
unsigned char SPI_TxFrame(unsigned char  *pBuffer, unsigned int   size)
{
	_disable_interrupts();
	unsigned char i=0;
	for(i=0;i<size;i++)						//Ȼη͸ֽ
	{
		Tx_Char(*pBuffer);
		pBuffer++;
	}
	 _enable_interrupts();
	return 1;
}

/******************************************************************************************************
 *        ƣSPI_RxFrame()
 *        ܣմӻ1֡
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
unsigned char SPI_RxFrame(unsigned char  *pBuffer, unsigned int size)
{
	unsigned char i=0;
	_disable_interrupts();
	for(i=0;i<size;i++)						//Ȼνոֽ
	{
		 *pBuffer=Rx_Char();
		 pBuffer++;
	}
	 _enable_interrupts();
	return 1;
}
/****************************************************************************
*        ƣSPI_HighSpeed()
*        ܣSPIΪ
* ڲ
* ڲ
* ˵       ЩSPI豸ɹڸSPI״̬
* ʹ÷
****************************************************************************/
void SPI_HighSpeed()
{
	SPI_Delay=1;
}
/****************************************************************************
*        ƣSPI_LowSpeed()
*        ܣSPIΪ
* ڲ
* ڲ
* ˵       ЩSPI豸ҪڵSPI״̬
* ʹ÷
****************************************************************************/
void SPI_LowSpeed()
{
 SPI_Delay=50;
}
#endif		//End of SOFT_SPI

#ifdef HARD_SPI			//Begin of HRAD_SPI

//-----ӲSPIܽź궨-----
#define SPI_SIMO        	BIT2		//1.2
#define SPI_SOMI        	BIT1		//1.1
#define SPI_CLK         	BIT4		//1.4
#define SPI_CS           	BIT4		//P2.4
//-----ӲSPIƶ˿ں궨-----
#define SPI_SEL2         	P1SEL2
#define SPI_SEL         		P1SEL
#define SPI_DIR         	P1DIR
#define SPI_OUT         	P1OUT
#define SPI_REN         	P1REN
//-----ʹܶCS˿ں궨-----
#define SPI_CS_SEL2       P2SEL2
#define SPI_CS_SEL       	 P2SEL
#define SPI_CS_OUT       P2OUT
#define SPI_CS_DIR       	 P2DIR

//-----巢/ջ-----
unsigned char  *SPI_Tx_Buffer;
unsigned char  *SPI_Rx_Buffer;
//-----/յֽ-----
unsigned char  SPI_Tx_Size=0;
unsigned char  SPI_Rx_Size=0;
//-----巢/ģʽ־-----
unsigned char SPI_Rx_Or_Tx =0;			// 0:	1   2շ
/****************************************************************************
*     ƣSPI_init()
*     ܣӲSPIгʼ
* ڲ
* ڲ
* ˵    ʹúĶдڳʼȵøóʼ
* ʹ÷SPI_init();
****************************************************************************/
void SPI_init(void)
{
    //-----ܽųʼΪ SPI -----
    SPI_SEL |= SPI_CLK + SPI_SOMI + SPI_SIMO;
    SPI_SEL2 |= SPI_CLK + SPI_SOMI + SPI_SIMO;
    SPI_DIR |= SPI_CLK + SPI_SIMO;
    //-----SD SPIģʽ£ҪSOMI-----
    SPI_REN |= SPI_SOMI;
    SPI_OUT |= SPI_SOMI;
    //-----ʹCSܽΪ-----
    SPI_CS_SEL   &= ~SPI_CS;
    SPI_CS_SEL2 &= ~SPI_CS;
    SPI_CS_OUT |= SPI_CS;
    SPI_CS_DIR  |= SPI_CS;
    //-----λUCA0-----
    UCA0CTL1 |= UCSWRST;
    //-----3-pin, 8-bit SPI ģʽ- ----
    UCA0CTL0 = UCCKPL + UCMSB + UCMST + UCMODE_0 + UCSYNC;
    //-----ʱѡSMCLKMSB first-----
    UCA0CTL1 = UCSWRST + UCSSEL_2;
    //-----f_UCxCLK = 12MHz/50 = 240kHz-----
    UCA0BR0 = 50;
    UCA0BR1 = 0;
    UCA0MCTL = 0;
    //-----UCA0-----
    UCA0CTL1 &= ~UCSWRST;
    //-----жϱ־λ-----
    IFG2 &= ~(UCA0RXIFG+UCA0TXIFG );
    __bis_SR_register(GIE);
}
/****************************************************************************
*        ƣSPI_CS_High()
*        ܣ3ӲSPIģʽʹCSܽΪߵƽ
* ڲ
* ڲ
* ˵       ˴CSܽſԸӲҪָܽCSɡ
* ʹ÷SPI_CS_High();
****************************************************************************/
void SPI_CS_High(void)
{
    SPI_CS_OUT |= SPI_CS;
}
/****************************************************************************
*     ƣSPI_CS_Low()
*     ܣ3ӲSPIģʽʹCSܽΪ͵ƽ
* ڲ
* ڲ
* ˵     ˴CSܽſԸӲҪָܽCSɡ
* ʹ÷SPI_CS_SLow();
****************************************************************************/
void SPI_CS_Low(void)
{
    SPI_CS_OUT &= ~SPI_CS;
}
/****************************************************************************
*     ƣSPI_Interrupt_Sel()
*     ܣͻж
* ڲonOff = 0 :رշжϣ򿪽жϣ
* 					onOff = 1 :رսжϣ򿪷жϣ
* ڲ
* ˵     ʹô˺ѡǰնģʽںж
* ʹ÷SPI_Interrupt_Sel(0);		// رշжϣ򿪽жϣ
* 					SPI_Interrupt_Sel(1);		// رսжϣ򿪷жϣ
****************************************************************************/
void SPI_Interrupt_Sel(unsigned char onOff)
{
	if(onOff == 0)						// ֻж
	{
		  IE2 &=~UCA0TXIE ;
		  IE2 |= UCA0RXIE ;
	}
	else	if(onOff==1)				// ֻж
	{
		  IE2 &=~UCA0RXIE ;
		  IE2 |= UCA0TXIE ;
	}
	else										//շȫ
	{
		 IE2 |= UCA0RXIE ;
		 IE2 |= UCA0TXIE ;
	}
}
/****************************************************************************
*     ƣSPI_RxFrame()
*     ܣ3ӲSPIģʽ£ָĿֽ
* ڲpBufferָŽݵ
* 					sizeҪյֽ
* ڲ0ǰӲSPIæ
* 					1ǰѷϣ
* ˵    ʹøúԽָһ֡
* ʹ÷SPI_RxFrame(CMD,6);// 6ֽڣηCMD
****************************************************************************/
unsigned char SPI_RxFrame(unsigned char  *pBuffer, unsigned int size)
{
	if(size==0)									return (1);
	if(UCA0STAT & UCBUSY)			return	(0);			// жӲSPIæ0
	 _disable_interrupts();											// رж
    SPI_Rx_Or_Tx = 0;													// ģʽ
    SPI_Rx_Buffer = pBuffer;										// ͻָ͵ַ
    SPI_Rx_Size = size-1;												// ͵ݸ
    SPI_Interrupt_Sel(SPI_Rx_Or_Tx);							// SPIжϿѡ
    _enable_interrupts();                                				// ж
    UCA0TXBUF = 0xff;													// ڽģʽ£ҲҪȷһοֽڣԱṩͨʱӡ
    _bis_SR_register(LPM0_bits);									// ͹ģʽ0
	return (1);
}
/****************************************************************************
*     ƣSPI_TxFrame()
*     ܣ3ӲSPIģʽ£ָĿֽڻ
* ڲpBufferָ͵ַ
* 					size͵ֽ
* ڲ0ǰӲSPIæ
* 					1ǰѷϣ
* ˵    ʹøúԷָһ֡
* ʹ÷SPI_TxFrame(CMD,6);	// CMDȡ6ֽ
****************************************************************************/
unsigned char SPI_TxFrame(unsigned char  *pBuffer, unsigned int  size)
{
	if(size==0)									return (1);
	if(UCA0STAT & UCBUSY)			return	(0);			// жӲSPIæ0
    _disable_interrupts();											// رж
    SPI_Rx_Or_Tx = 1;													// ģʽ
    SPI_Tx_Buffer = pBuffer;										// ͻָ͵ַ
    SPI_Tx_Size = size-1;												// ͵ݸ
    SPI_Interrupt_Sel(SPI_Rx_Or_Tx);							// SPIжϿѡ
    _enable_interrupts();	                               				// ж
    UCA0TXBUF = *SPI_Tx_Buffer;								// ȷ͵һֽ˹һ""ж
	_bis_SR_register(LPM0_bits);									// ͹ģʽ0
	return (1);
}
//-----ǰ¼-----
static void SPI_TxISR();
static void SPI_RxISR();
/******************************************************************************************************
 *        ƣUSCI0TX_ISR_HOOK()
 *        ܣӦTxжϷ
 * ڲ
 * ڲ
 * ˵       ѭCPUĴ
 *        
 ******************************************************************************************************/
#pragma vector=USCIAB0TX_VECTOR
__interrupt void USCI0TX_ISR_HOOK(void)
{
	//-----ж¼溯-----
	SPI_TxISR();
	//-----жϴ˴βǷɣ˳͹-----
	 if(SPI_Tx_Size==0)
	_bic_SR_register_on_exit(LPM0_bits);
}
/******************************************************************************************************
 *        ƣUSCI0RX_ISR_HOOK()
 *        ܣӦRxжϷ
 * ڲ
 * ڲ
 * ˵       ѭCPUĴ
 *        
 ******************************************************************************************************/
#pragma vector=USCIAB0RX_VECTOR
__interrupt void USCI0RX_ISR_HOOK(void)
{
	//-----ж¼溯-----
	 SPI_RxISR();
	//-----жϴ˴βǷɣ˳͹-----
	 if(SPI_Rx_Size==0)
	_bic_SR_register_on_exit(LPM0_bits);
}
/******************************************************************************************************
 *        ƣSPI_RxISR()
 *        ܣSPIRx¼
 * ڲ
 * ڲ
 * ˵       ԽյݣԴд
 *        
 ******************************************************************************************************/
static void SPI_RxISR()
{

	*SPI_Rx_Buffer = UCA0RXBUF;								//  ȡջ棬ͬʱUCA0RXIFGжϱ־λ
	if(SPI_Rx_Size!=0)
	{
		SPI_Rx_Size-- ;														// ͵ݼ1
		SPI_Rx_Buffer++;												// ָһֽƫ
		UCA0TXBUF = 0xff;												// ΪṩCLKUCA0TXIFG־λͬʱ
	}
    IFG2 &= ~UCA0TXIFG;                                   			// жϱ־λ

}
/******************************************************************************************************
 *        ƣSPI_TxISR()
 *        ܣSPITx¼
 * ڲ
 * ڲ
 * ˵       ԽյݣԴд
 *        
 ******************************************************************************************************/
static void SPI_TxISR()
{
    UCA0RXBUF;                                            				// TxRxжϱ־λλ˴UCA0RXBUFղUCA0RXIFGжϱ־λ
	if(SPI_Tx_Size!=0)
	{
		SPI_Tx_Size-- ;														// ͵ݼ1
		SPI_Tx_Buffer++;											// ָһֽƫ
		UCA0TXBUF = *SPI_Tx_Buffer;							// 뷢ͻ棬ͬʱUCA0TXIFGжϱ־λ
	}
	else
		IFG2 &= ~UCA0TXIFG;                                   		// һΣڲUCA0TXBUFвҪΪжϱ־λ
}
/****************************************************************************
*        ƣSPI_HighSpeed()
*        ܣSPIΪ
* ڲ
* ڲ
* ˵       ЩSPI豸ɹڸSPI״̬
* ʹ÷
****************************************************************************/
void SPI_HighSpeed()
{
	UCA0CTL1 |= UCSWRST;
	UCA0BR0 = 2;                                // f_UCxCLK = 12MHz/2 = 6MHz
	UCA0BR1 = 0;
	UCA0MCTL = 0;
	UCA0CTL1 &= ~UCSWRST;
}
/****************************************************************************
*        ƣSPI_LowSpeed()
*        ܣSPIΪ
* ڲ
* ڲ
* ˵       ЩSPI豸ҪڵSPI״̬
* ʹ÷
****************************************************************************/
void SPI_LowSpeed()
{
    UCA0CTL1 |= UCSWRST;
    UCA0BR0 =50;                          		// f_UCxCLK = 12MHz/50 = 240KHz
    UCA0BR1 = 0;
    UCA0MCTL = 0;
    UCA0CTL1 &= ~UCSWRST;
}
#endif	//end of HARD_SPI
