/*
 * main.c
 */
#include"MSP430G2553.h"
#include "Slope.h"
#include "TCA6416A.h"
#include "HT1621.h"
#include "LCD_128.h"

unsigned char Key=0;		//̵λĵЧֵ
//-----⡰衱ķֵֵʵʽ5kֵ+10k̵λ-----
const unsigned char R_Class[8]={55,67,82,97,113,128,138,144};		//λΪŷ

void WDT_OnTime();
void Slope_R_Dect();			//ô¼
void TCA6416A_LED(unsigned char num);		//LEDʾ
void Display_SLOPE();
void Display_RSENS(unsigned char Rsens);

void main(void) {
	WDTCTL=WDTPW+WDTHOLD;
    BCSCTL1 = CALBC1_16MHZ;      /* Set DCO to16MHz */
    DCOCTL = CALDCO_16MHZ;
	__delay_cycles(100000);			//ȴѹȶ
	TCA6416A_Init();
	Slope_Measure_Init();
	HT1621_init();
	LCD_Clear();
	Display_SLOPE();
	HT1621_Reflash(LCD_Buffer);
	//-----趨WDTΪ16msʱж-----
	WDTCTL=WDT_ADLY_16;
	//-----WDTжʹ-----
    IE1|=WDTIE;
	 _enable_interrupts();

	while(1);
}

/******************************************************************************************************
 *        ƣWDT_ISR(void)
 *        ܣWDTʱжӺ
 * ڲ
 * ڲ
 * ˵       ֱӵ¼
 *        
 ******************************************************************************************************/
#pragma vector=WDT_VECTOR
__interrupt void WDT_ISR(void)
{
	 IE1&=~WDTIE;
	WDT_OnTime();
	 IE1|=WDTIE;
}
/******************************************************************************************************
 *        ƣWDT_OnTime()
 *        ܣWDTʱжϵ¼
 * ڲ
 * ڲ
 * ˵       Ҫ¼
 *        
 ******************************************************************************************************/
void WDT_OnTime()
{
	static unsigned char Charge_Ready=0;			//־λ
	static unsigned char REF_Mreasure_Ready=0;	//8οѲ
	static unsigned long R_REF_Sum=0;			//ݴοۼֵ
		if(Charge_Ready==0)		//δ
		{
			Slope_Port_Charge();	//
			Slope_R_Dect();			//ִʾLED
			Charge_Ready=1;		//־
		}
		else
		{
			//-----8βοֵ-----
			if(REF_Mreasure_Ready<8)					// жǷοֵ
			{
				Slope_Measure_REF();						//οֵ
				R_REF_Sum=R_REF_Sum+R_REF;		//ۼӵֵ
				if(REF_Mreasure_Ready==7)	R_REF=R_REF_Sum>>3;	//οƽֵ
				REF_Mreasure_Ready++;					//ۼ
			}
			//-----õοֵ󣬿ʼͣĲֵ-----
			else
				Slope_Measure_SENS();					//οŲ⴫
				Charge_Ready=0;							//һΣָó
		}
}

/******************************************************************************************************
 *        ƣSlope_R_Dect()
 *        ܣԴжϵλLEDʾ
 * ڲ
 * ڲ
 * ˵       Ҫ¼
 *        
 ******************************************************************************************************/
void Slope_R_Dect()
{
	static unsigned int Rsens=0;
	unsigned char Key_Last=0;		//жǷи
	Key_Last=Key;
	//-----ͨ10kο裬ֵλŷ-----
	Rsens=(((unsigned long int)100)*(unsigned long int)R_SENS)/R_REF;
	//-----ֵжϣ5k15k֮䣬8-----
	if(Rsens<=R_Class[0]) 			Key=0;
	else if (Rsens<=R_Class[1]) 	Key=1;
	else if (Rsens<=R_Class[2])	Key=2;
	else if (Rsens<=R_Class[3]) 	Key=3;
	else if (Rsens<=R_Class[4]) 	Key=4;
	else if (Rsens<=R_Class[5]) 	Key=5;
	else if (Rsens<=R_Class[6]) 	Key=6;
	else 	if(Rsens<=R_Class[7]) 	Key=7;
	else											Key=8;
	//-----һϵʾ-----
	Display_RSENS(Rsens);		//ʾʵʵֵ
	if(!(Key==Key_Last))			//ʾֵֵ
	{
		LCD_DisplayDigit(LCD_DIGIT_CLEAR ,6);
		LCD_DisplayDigit(Key,6);
		HT1621_Reflash_Digit(6);
	}
	TCA6416A_LED(Key);		 	//LEDʾ
}
/******************************************************************************************************
 *        ƣTCA6416A_LED()
 *        ܣݴֵʵLEDЧ
 * ڲ
 * ڲ
 * ˵       ҪI2CTCA6416LED
 *        
 ******************************************************************************************************/
void TCA6416A_LED(unsigned char num)
{
	unsigned char i = 0;
	for(i=0;i<8;i++)
	{
		if(i<num)					// жϵǰҪյ
			PinOUT(i,0);			//LEDӷIO͵ƽΪLED
		else
			PinOUT(i,1);			//LEDӷIOߵƽΪϨLED
	}
}
/******************************************************************************************************
 *        ƣDisplay_SLOPE()
 *        ܣLEDʾ̶
 * ڲ
 * ڲ
 * ˵       ʾSLOPE2С㣬logokλ
 *        
 ******************************************************************************************************/
void Display_SLOPE()
{
	//-----ʾS-----
	LCD_DisplayDigit(5,1);
	//-----ʾL-----
	LCD_DisplayDigit(0,2);
	LCD_ClearSeg(_LCD_2A);
	LCD_ClearSeg(_LCD_2B);
	LCD_ClearSeg(_LCD_2C);
	//-----ʾO-----
	LCD_DisplayDigit(0,3);
	//-----ʾP-----
	LCD_DisplayDigit(8,4);
	LCD_ClearSeg(_LCD_4C);
	LCD_ClearSeg(_LCD_4D);
	//-----ʾE-----
	LCD_DisplayDigit(8,5);
	LCD_ClearSeg(_LCD_5B);
	LCD_ClearSeg(_LCD_5C);
	//-----ʾС-----
	LCD_DisplaySeg(_LCD_DOT4);
	LCD_DisplaySeg(_LCD_DOT6);
	//-----ʾlogo-----
	LCD_DisplaySeg(_LCD_TI_logo);
	LCD_DisplaySeg(_LCD_QDU_logo);
	//-----ʾk-----
	LCD_DisplaySeg(_LCD_k_OHOM);
	LCD_DisplaySeg(_LCD_OHOM);
}
/******************************************************************************************************
 *        ƣDisplay_RSENS()
 *        ܣLEDС8ֶʾʵ⴫ֵ
 * ڲ
 * ڲ
 * ˵       λиıŸ¸λԴ档
 *        
 ******************************************************************************************************/
void Display_RSENS(unsigned char Rsens)
{
	unsigned char i=0;
	static unsigned char Digit[3]={0};
	unsigned char Digit_Past[3]={0};		//ڶԱֵǷиı
	for(i=0;i<3;i++){
		Digit_Past[i]=Digit[i];
	}
	//----------
	Digit[2]=Rsens/100;
	Digit[1]=(Rsens%100)/10;
	Digit[0]=Rsens%10;
	//-----бλĸı䣬¸λԴ-----
	for(i=0;i<3;i++)
	{
		if(!(Digit[i]==Digit_Past[i]))		//б仯
		{
			LCD_DisplayDigit(LCD_DIGIT_CLEAR ,i+8);	//8ֶ
			LCD_DisplayDigit(Digit[i],i+8);						//дԴӳ
			HT1621_Reflash_Digit(i+8);							//¸8ֶεԴ
		}
	}
}

