/*
 * main.c
 */
#include "msp430g2553.h"
#include"SD_HardWare.h"
#include "SD_SPI.h"
#include"SPI.h"
#include "DAC8411.h"
#include "softFIFO.h"
//#define  WAV_SECTOR    532615			// TFи׵ַ   532615
//#define  WAV_SECTOR    2642695		// TFи׵ַ   2642695кһTF
#define  WAV_SECTOR    672		// TFи׵ַ   672к128MTF
#define SYSCLK 12000000						//ϵͳʱ
#define SAMPLE_FREQ 11025				//ƵļĲ
#define VOL_REDUCE   1  					//ȡ2Nη
void Time0_A_Init();
 char SD_Read_InFIFO(unsigned long sector);
 void TA0_OnTime();
 void main()
 {
     WDTCTL = WDTPW + WDTHOLD;
 	BCSCTL1 = CALBC1_12MHZ;                   // Set range
 	DCOCTL = CALDCO_12MHZ;                    // Set DCO step + modulation
 	//-----ʼSPI-----
 	 SPI_init();
  	//-----ʼSD-----
 	 SD_Init();
 	DAC8411_Init();
 	// -----ʼʶʱ-----
 	Time0_A_Init();
 	while(1)
 	{
 		 SD_Read_InFIFO(WAV_SECTOR);			// ȡָ
 	}
 }
 /******************************************************************************************************
  *        ƣSD_Read_InFIFO(unsigned long sector)
  *        ܣͣĶȡSD
  * ڲͷַ
  * ڲ
  * ˵       SD⺯ͬǣȡFIFOд
  *        
  ******************************************************************************************************/
 char SD_Read_InFIFO(unsigned long sector)
 {
 	unsigned char CMD[6]={0};
 	static unsigned  long sec=1750;			// Ԥ""ȡƫƣಿ
    unsigned char retry = 0;
    unsigned char temp = 0;
    unsigned int i=0;
    sector = (sector+sec )<<9;					     //ת߼ַ
    //=====²SD⺯һ=====
    CMD[0]=0x51;	   									//SD_CMD17
    //-----ת32λַ-----
    CMD[1]= ((sector & 0xff000000) >>24);
    CMD[2]= ((sector & 0x00ff0000) >>16);
    CMD[3]= ((sector & 0x0000ff00) >>8);
    CMD[4]= sector & 0x000000ff;
    CMD[5]=0xFF;										    //SD_SPI_CRC
 	sec ++;				//
    //-----дSD100ֱӦ-----
       do
    {
       temp = Write_Command_SD(CMD);
       retry++;
       if(retry == 100)
       {
         return(0);
       }
    } while(temp!=0);
      while (SD_Read_Byte() != 0xfe) ;	//Ӧȷ
    //=====ϲֺSD⺯һ£²ָΪдݵFIFO=====
    for(i=0;i<512;i++)
    {
 	   while(FIFO_Count>= FIFOBUFF_SIZE)
 		   _NOP();															// FIFO ȴFIFOеȡ
 	   Write_FIFO(SD_Read_Byte());							//дFIFO
    }
    //-----ѭУλ-----
    SD_Read_Byte();													//CRC - Byte
    SD_Read_Byte();													//CRC - Byte

 	SD_CS_High();														//CSƬѡ
    return(1);
 }
//==============Ϊͺ̨Ϊǰ̨򲿷================
/******************************************************************************************************
 *        ƣTime0_A_Init()
 *        ܣʼTA0
 * ڲ
 * ڲ
 * ˵       ǳʼIO״̬
 *        
 ******************************************************************************************************/
void Time0_A_Init()
{
  TA0CCTL0 = CCIE;                         	// Ƚ/ģ0ж
  TA0CCR0 = SYSCLK/SAMPLE_FREQ;		//趨TAʱ
  TA0CTL = TASSEL_2 + MC_1;           //TA0Ϊģʽʱ=SMCLK
  _enable_interrupts();                       //ȫжϣ
}
/******************************************************************************************************
 *        ƣTimer0_A0
 *        ܣTACCR0жϷ
 * ڲ
 * ڲ
 * ˵       жԴռжڣж
 *        
 ******************************************************************************************************/
#pragma vector=TIMER0_A0_VECTOR
__interrupt void Timer0_A0 (void)
{
	TA0CCTL0 &= ~CCIE;                       // رձȽ/ģ0ж
	TA0_OnTime();
	TA0CCTL0 = CCIE;                         // Ƚ/ģ0ж
}
/******************************************************************************************************
 *        ƣ TA0_OnTime()
 *        ܣTA0Ķʱ¼
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
void TA0_OnTime()
{
	unsigned int temp =0,tempL=0,tempH=0;
 	if(FIFO_Count != 0)
 	{
 		tempL =  Read_FIFO();
 		tempH =  Read_FIFO();
 		temp = ((tempH<<8) &0xff00)|(tempL &0x00ff);
		temp = temp+0x8000;	      //з޷
 		write2DAC8411(temp/VOL_REDUCE);
 	}
}


