/*
 * SPI.c
ӲSPI
 *  Created on: 2013-4-3
 *      Author: Administrator
 */

#include"MSP430G2553.h"
#include"SPI.h"


//*********************************ӲSPIײ**********************************
//-----ӲSPIܽź궨-----
#define SPI_SIMO        	BIT2		//1.2
#define SPI_SOMI        	BIT1		//1.1
#define SPI_CLK         	BIT4		//1.4
#define SPI_CS           	BIT4		//P2.4
//-----ӲSPIƶ˿ں궨-----
#define SPI_SEL2         	P1SEL2
#define SPI_SEL         		P1SEL
#define SPI_DIR         	P1DIR
#define SPI_OUT         	P1OUT
#define SPI_REN         	P1REN
//-----ʹܶCS˿ں궨-----
#define SPI_CS_SEL2       P2SEL2
#define SPI_CS_SEL       	 P2SEL
#define SPI_CS_OUT       P2OUT
#define SPI_CS_DIR       	 P2DIR


/****************************************************************************
*     ƣSPI_init()
*     ܣӲSPIгʼ
* ڲ
* ڲ
* ˵    ʹúĶдڳʼȵøóʼ
* ʹ÷SPI_init();
****************************************************************************/
void SPI_init(void)
{
    //-----ܽųʼΪ SPI -----
    SPI_SEL |= SPI_CLK + SPI_SOMI + SPI_SIMO;
    SPI_SEL2 |= SPI_CLK + SPI_SOMI + SPI_SIMO;
    SPI_DIR |= SPI_CLK + SPI_SIMO;
    //-----SD SPIģʽ£ҪSOMI-----
    SPI_REN |= SPI_SOMI;
    SPI_OUT |= SPI_SOMI;
    //-----ʹCSܽΪ-----
    SPI_CS_SEL   &= ~SPI_CS;
    SPI_CS_SEL2 &= ~SPI_CS;
    SPI_CS_OUT |= SPI_CS;
    SPI_CS_DIR  |= SPI_CS;
    //-----λUCA0-----
    UCA0CTL1 |= UCSWRST;
    //-----3-pin, 8-bit SPI ģʽ- ----
    UCA0CTL0 = UCCKPL + UCMSB + UCMST + UCMODE_0 + UCSYNC;
    //-----ʱѡSMCLKMSB first-----
    UCA0CTL1 = UCSWRST + UCSSEL_2;
    //-----f_UCxCLK = 12MHz/50 = 240kHz-----
    UCA0BR0 = 50;
    UCA0BR1 = 0;
    UCA0MCTL = 0;
    //-----UCA0-----
    UCA0CTL1 &= ~UCSWRST;
    //-----жϱ־λ-----
    IFG2 &= ~(UCA0RXIFG+UCA0TXIFG );
    __bis_SR_register(GIE);
}
/****************************************************************************
*        ƣSPI_CS_High()
*        ܣ3ӲSPIģʽʹCSܽΪߵƽ
* ڲ
* ڲ
* ˵       ˴CSܽſԸӲҪָܽCSɡ
* ʹ÷SPI_CS_High();
****************************************************************************/
void SPI_CS_High(void)
{
    SPI_CS_OUT |= SPI_CS;
}
/****************************************************************************
*        ƣSPI_HighSpeed()
*        ܣSPIΪ
* ڲ
* ڲ
* ˵       ЩSPI豸ɹڸSPI״̬
* ʹ÷
****************************************************************************/
void SPI_HighSpeed()
{
	UCA0CTL1 |= UCSWRST;
	UCA0BR0 = 2;                                // f_UCxCLK = 12MHz/2 = 6MHz
	UCA0BR1 = 0;
	UCA0MCTL = 0;
	UCA0CTL1 &= ~UCSWRST;
}
/****************************************************************************
*        ƣSPI_LowSpeed()
*        ܣSPIΪ
* ڲ
* ڲ
* ˵       ЩSPI豸ҪڵSPI״̬
* ʹ÷
****************************************************************************/
void SPI_LowSpeed()
{
    UCA0CTL1 |= UCSWRST;
    UCA0BR0 =50;                          		// f_UCxCLK = 12MHz/50 = 240KHz
    UCA0BR1 = 0;
    UCA0MCTL = 0;
    UCA0CTL1 &= ~UCSWRST;
}
/****************************************************************************
*     ƣSPI_CS_Low()
*     ܣ3ӲSPIģʽʹCSܽΪ͵ƽ
* ڲ
* ڲ
* ˵     ˴CSܽſԸӲҪָܽCSɡ
* ʹ÷SPI_CS_SLow();
****************************************************************************/
void SPI_CS_Low(void)
{
    SPI_CS_OUT &= ~SPI_CS;
}

/***************************************************************************
*     ƣSPI_RxFrame()
*     ܣ3ӲSPIģʽ£ָĿֽ
* ڲpBufferָŽݵ
* 					sizeҪյֽ
* ڲ0ǰӲSPIæ
* 					1ǰѷϣ
* ˵    ʹøúԽָһ֡
* ʹ÷SPI_RxFrame(CMD,6);// 6ֽڣηCMD
 ******************************************************************************/
unsigned char SPI_RxFrame(unsigned char  *pBuffer, unsigned int size)
{
    unsigned int gie = __get_SR_register() & GIE;              //浱ǰ ȫ GIE ״̬
//    __disable_interrupt();                                 						//ֹж
    IFG2 &= ~UCA0RXIFG;                                   				//жϱ־λ
    while (size--){
        while (!(IFG2 & UCA0TXIFG)) ;                    			 	//ȴ
        UCA0TXBUF = 0xff;                                  					//Ϳֽ
        while (!(IFG2 & UCA0RXIFG)) ;                     				//ȴ
        *pBuffer++ = UCA0RXBUF;
    }
//    __bis_SR_register(gie);                               						 //ԭȫжϢ
    return 1;
}
/***************************************************************************//**
*     ƣSPI_TxFrame()
*     ܣ3ӲSPIģʽ£ָĿֽڻ
* ڲpBufferָ͵ַ
* 					size͵ֽ
* ڲ0ǰӲSPIæ
* 					1ǰѷϣ
* ˵    ʹøúԷָһ֡
* ʹ÷SPI_TxFrame(CMD,6);	// CMDȡ6ֽ
 ******************************************************************************/
unsigned char SPI_TxFrame(unsigned char  *pBuffer, unsigned int  size)
{
	unsigned int  gie = __get_SR_register() & GIE;              //浱ǰ ȫ GIE ״̬
//	_disable_interrupts();                                		 				 //ֹж
    while (size--){
        while (!(IFG2 & UCA0TXIFG)) ;                   					 //ȴ
        UCA0TXBUF = *pBuffer++;                       					 //ддֽ
    }
    while (UCA0STAT & UCBUSY) ;                     					 //ȴշ

    UCA0RXBUF;                                            	   					 //նRXBUFһдϢ
 //   _bis_SR_register(gie);                                					 //ԭȫжϢ
    return 1;
}
